static int mbtk_test_draw_color(mbtk_window_t *win, int r, int g, int b, int a)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_color: W%d, #%02x%02x%02x%02x \n", tw->id, r, g, b, a);
	return 0;
}

static void mbtk_test_draw_fillrect(mbtk_window_t *win, int x1, int y1, int x2, int y2)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_fillrect: W%d, %d;%d %d;%d\n", tw->id, x1, y1, x2, y2);
}

static void mbtk_test_draw_line(mbtk_window_t *win, int x1, int y1, int x2, int y2)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_line: W%d, %d;%d %d;%d\n", tw->id, x1, y1, x2, y2);
}

static void mbtk_test_draw_hline(mbtk_window_t *win, int x1, int y1, int x2)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_hline: W%d, %d;%d %d;*\n", tw->id, x1, y1, x2);
}

static void mbtk_test_draw_vline(mbtk_window_t *win, int x1, int y1, int y2)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_vline: W%d, %d;%d *;%d\n", tw->id, x1, y1, y2);

}

int mbtk_test_draw_set_font(mbtk_window_t *win, mbtk_font_id_t fontid)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_set_font: W%d, F%ld\n", tw->id, fontid.l);
	return 0;
}

static void mbtk_test_draw_query_text(mbtk_window_t *win, int *wo, int *asco, int *desco, char *s, int slen)
{
	test_win_t *tw = (test_win_t *)win;

	*wo = slen * 8;
	*asco = 10;
	*desco = 6;

	printf("draw_query_text: W%d, '%s' %d -> %d %d %d\n", tw->id, s, slen, *wo, *asco, *desco);
}

static void mbtk_test_draw_text(mbtk_window_t *win, int x, int y, char *s, int slen, void **cache)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_set_font: W%d, %d;%d '%s' %d\n", tw->id, x, y, s, slen);
}

static int mbtk_test_draw_import_pixmap(mbtk_display_t *display, mbtk_pixmap_t *dst, unsigned char *pixels, int width, int height, int has_alpha)
{
	test_display_t *td = (test_display_t *)display;

	dst->bedata.ul = ++td->pxids;
	printf("draw_import_pixmap: %d;%d %d -> P%ld\n", width, height, has_alpha, dst->bedata.ul);

	return 0;
}

static void mbtk_test_draw_free_pixmap(mbtk_display_t *display, mbtk_pixmap_t *px)
{
	printf("draw_free_pixmap: P%ld\n", px->bedata.ul);
}

static mbtk_px_id_t mbtk_test_draw_bind_pixmap(mbtk_window_t *win, mbtk_pixmap_t *px)
{
	test_win_t *tw = (test_win_t *)win;
	mbtk_px_id_t pxid;
	pxid.l = px->bedata.ul;
	
	printf("draw_bind_pixmap: W%d, P%ld\n", tw->id, pxid.l);
	return pxid;
}

static void mbtk_test_draw_pixmap(mbtk_window_t *win, int x, int y, mbtk_px_id_t pxid)
{
	test_win_t *tw = (test_win_t *)win;

	printf("draw_pixmap: W%d, %d;%d, P%ld\n", tw->id, x, y, pxid.l);
}


static void mbtk_test_draw_flush(mbtk_window_t *win)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_flush: W%d\n", tw->id);
}


static void mbtk_test_draw_start(mbtk_window_t *win)
{
	test_win_t *tw = (test_win_t *)win;
	printf("draw_start: W%d\n", tw->id);
}

