#include <stdlib.h>
#include <string.h>
#include <genht/htsi.h>
#include <genht/hash.h>
#include <assert.h>
#include "keywords.h"
#include "util.h"

static htsi_t *mbtk_keywords = NULL;
static mbtk_kw_t mbtk_kw_next = 1;

mbtk_kw_t mbtk_kw(const char *name)
{
	mbtk_kw_t kw;

	if (mbtk_keywords == NULL) {
		mbtk_keywords = htsi_alloc(strhash, strkeyeq);
		assert(mbtk_keywords != NULL);
	}
	kw = htsi_get(mbtk_keywords, (char *)name);
	if (kw == mbtk_kw_invalid) {
		kw = mbtk_kw_next++;
		htsi_set(mbtk_keywords, mbtk_strdup(name), kw);
	}
	return kw;
}

mbtk_kw_t mbtk_kw_uniq(void)
{
	return mbtk_kw_next++;
}

void mbtk_kw_uninit(void)
{
	htsi_entry_t *e;
	for (e = htsi_first(mbtk_keywords); e; e = htsi_next(mbtk_keywords, e))
		free(e->key);

	htsi_free(mbtk_keywords);
	mbtk_keywords = NULL;
}
