#include "window.h"
#include "style.h"

int mbtk_style_set_prop(const mbtk_style_t *style, mbtk_styleprop_t *dst, mbtk_kw_t key, mbtk_arg_t value)
{
	if ((style == NULL) || (style->getset_prop == NULL))
		return -1;

	return style->getset_prop(style, dst, key, NULL, &value);
}

int mbtk_style_get_prop(const mbtk_style_t *style, mbtk_styleprop_t *src, mbtk_kw_t key, mbtk_arg_t *dst)
{
	if ((style == NULL) || (style->getset_prop == NULL))
		return -1;

	return style->getset_prop(style, src, key, dst, NULL);
}


int mbtk_display_style_set_prop(mbtk_display_t *dst, mbtk_kw_t key, mbtk_arg_t value)
{
	return mbtk_style_set_prop(dst->style, dst->styleprop, key, value);
}

int mbtk_display_style_get_prop(mbtk_display_t *src, mbtk_kw_t key, mbtk_arg_t *dst)
{
	return mbtk_style_get_prop(src->style, src->styleprop, key, dst);
}

mbtk_kw_t mbtk_kw_bg_color, mbtk_kw_bg_activated_color, mbtk_kw_fg_color, mbtk_kw_frame_width;
mbtk_kw_t mbtk_kw_hilight_color;
mbtk_kw_t mbtk_kw_text_halign, mbtk_kw_text_valign;

void mbtk_style_init(void)
{
	mbtk_kw_bg_color = mbtk_kw("bg.color");
	mbtk_kw_bg_activated_color = mbtk_kw("bg_activated.color");
	mbtk_kw_fg_color = mbtk_kw("fg.color");
	mbtk_kw_hilight_color = mbtk_kw("hilight.color");
	mbtk_kw_frame_width = mbtk_kw("frame.width");
	mbtk_kw_text_halign = mbtk_kw("text.halign");
	mbtk_kw_text_valign = mbtk_kw("text.valign");
}
