#include <stdio.h>
#include <libmbtk/global_typedefs.h>
#include <libmbtk/handler.h>
#define MBTK_NO_INCLUDE_WIDGETS
#include <libmbtk/widget.h>
#include <libmbtk/widget_imp.h>

static const char my_name[] = "hand_outclk";

typedef struct mbtk_outclk_handler_s {
	mbtk_handler_t hdr;
} mbtk_outclk_handler_t;

static mbtk_outclk_handler_t outclk_handler;
static int outclk_handler_inited = 0;


static mbtk_event_handled_t outclk_event(mbtk_widget_t *widget, mbtk_event_t *ev)
{
	if (ev->type == MBTK_EV_FOCUS_MOUSE_PRESS_OUT) {
		mbtk_kw_t kw_outclk;

printf("hand OUTCLK\n");

		mbtk_kw_cache(kw_outclk, "outclk");
		mbtk_callback_noarg(widget, kw_outclk);

		return MBTK_EVENT_HANDLED;
	}
	return MBTK_EVENT_NOT_HANDLED;
}


void mbtk_handler_outclk_install(mbtk_widget_t *widget)
{
	if (widget->handler != NULL)
		mbtk_widget_del_handler(widget);

	if (!outclk_handler_inited) {
		outclk_handler.hdr.name = my_name;
		outclk_handler.hdr.event = outclk_event;
		outclk_handler_inited = 1;
	}
	widget->handler = &outclk_handler.hdr;
}
