#ifndef LIBMBTK_WIDGET_MENU_H
#define LIBMBTK_WIDGET_MENU_H

#include <libmbtk/config.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>
#include <libmbtk/widget/box.h>
#include <libmbtk/widget/hand_hovradio.h>

/* A VBOX of menu items, each item being a widget, typically a label or a
   HBOX of app supplied widgets */

typedef struct mbtk_menu_s {
	mbtk_widget_t w;            /* ->win is NULL or the primary menu window, the only one open menu-window of the menu, starting from it's parent_item */
	mbtk_widget_t *parent_item; /* a widget in mbtk_menu_t or mbtk_menu_bar_t */
	vtp0_t menus;
	mbtk_handler_hovradio_t radio;

	vtp0_t toff_win;            /* unordered list of all open (mbtk_window_t *) torn-off windows */
} mbtk_menu_t;

/* Create a new, empty menu  */
mbtk_menu_t *mbtk_menu_new(mbtk_menu_t *caller_alloced);

/* Open or close the primary menu window */
void mbtk_menu_open_dropdown(mbtk_menu_t *menu, long screen_x, long screen_y);
void mbtk_menu_open_popup(mbtk_menu_t *menu, long screen_x, long screen_y);
void mbtk_menu_close(mbtk_menu_t *menu);

/* Append an item at the end of the list. The generic version accepts
   any widget for the item label (should be a label or picture normally); the
   _label version creates the label widget from item_name. */
void mbtk_menu_append(mbtk_menu_t *menu, mbtk_widget_t *item);
void mbtk_menu_append_label(mbtk_menu_t *menu, const char *item_name);


MBTK_WIDGET_INLINES(menu)

#endif
