#ifndef LIBMBTK_WIDGET_MENU_BAR_H
#define LIBMBTK_WIDGET_MENU_BAR_H

#include <libmbtk/config.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>
#include <libmbtk/widget/menu.h>
#include <libmbtk/widget/hand_hovradio.h>

/* A HBOX of menu labels, each opening a menu */

typedef struct mbtk_menu_bar_s {
	mbtk_widget_t w;
	vtp0_t menus;
	mbtk_handler_hovradio_t radio;
} mbtk_menu_bar_t;

/* Create a new, empty menu_bar  */
mbtk_menu_bar_t *mbtk_menu_bar_new(mbtk_menu_bar_t *caller_alloced);

/* Append a menu at the end of the list. The generic version accepts
   any widget for the menu label (should be a label or picture normally); the
   _label version creates the label widget from menu_name. */
void mbtk_menu_bar_append(mbtk_menu_bar_t *menu_bar, mbtk_widget_t *label, mbtk_menu_t *menu);
void mbtk_menu_bar_append_label(mbtk_menu_bar_t *menu_bar, const char *menu_name, mbtk_menu_t *menu);


MBTK_WIDGET_INLINES(menu_bar)

#endif
