#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libmbtk/libmbtk.h>
#include <libmbtk/display.h>
#include <libmbtk/timer.h>
#include "../be_init.h"

int stay = 1;

static mbtk_timer_res_t timer_cb(long repleft, void *user_data)
{
	printf("timer c: %s %ld\n", (char *)user_data, repleft);
	return MBTK_TIMER_CONTINUE;
}

static mbtk_timer_res_t stop_cb(long repleft, void *user_data)
{
	printf("timer s: %s %ld\n", (char *)user_data, repleft);
	return MBTK_TIMER_STOP;
}

static mbtk_timer_res_t quit_cb(long repleft, void *user_data)
{
	stay = 0;
	printf("timer q\n");
	return MBTK_TIMER_STOP;
}

int main(int argc, char *argv[])
{
	mbtk_backend_t be;
	mbtk_display_t disp;
	mbtk_timer_id_t t1, t2, ts, tq;

	tests_backend_init(&be, &disp, &argc, &argv);

	t1 = mbtk_timer_new(&disp, 4, 0.2, timer_cb, "first");
	t2 = mbtk_timer_new(&disp, 8, 0.15, timer_cb, "second"); /* get stopped by the main loop after a while */
	ts = mbtk_timer_new(&disp, 3, 0.31, stop_cb, "stopper"); /* stops after the first run */
	tq = mbtk_timer_new(&disp, 1, 1.5, quit_cb, "quitter");  /* wait until all the above expire and then quit */

	printf("Timers: t1=%ld t2=%ld ts=%ld tq=%ld\n", t1, t2, ts, tq);

	while(stay) {
		mbtk_event_t ev;
		mbtk_iterate(&disp, &ev, 0);
		printf("idle\n");
		if (mbtk_timer_get_repleft(&disp, t2) == 2) /* stop t2 when only 2 iterations would be left */
			printf("STOP t2: %d\n", mbtk_timer_stop(&disp, t2));
	}

	mbtk_uninit();
}
