#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <libmbtk/libmbtk.h>
#include <libmbtk/widget.h>
#include <libmbtk/style_f3d.h>
#include <libmbtk/arg_t.h>
#include <libmbtk/mpm.h>
#include "../be_init.h"

static char **font;
static int stay;

static mbtk_event_handled_t button_toggle(mbtk_widget_t *w, mbtk_kw_t id, void *user_data)
{
	fprintf(stderr, "Toggle: '%s' %d\n", (const char *)user_data, w->flags.activated);
	return 0;
}

int main(int argc, char *argv[])
{
	mbtk_window_t *win;
	mbtk_backend_t be;
	mbtk_display_t disp;
	mbtk_box_t *vbox, *hbox1;
	mbtk_radiobutton_t *wrb;
	mbtk_handler_hovradio_t *hrr;

	font = tests_backend_init(&be, &disp, &argc, &argv);
	mbtk_f3d_style(&disp);


	disp.default_fid = mbtk_resolve_font(&disp, 1, font);

	win = mbtk_window_new(&disp, MBTK_WNTY_NORMAL, "miniboxtk odd widgets", -1, -1, 300, 300);
	if (win == NULL) {
		fprintf(stderr, "Unable to create top window\n");
		exit(1);
	}

	vbox = mbtk_vbox_new(NULL);
	mbtk_window_set_root_widget(win, &vbox->w);

	/*** Radio button ***/

	/* create and append a hbox; this will host our example radio buttons */
	hbox1 = mbtk_hbox_new(NULL);
	mbtk_box_add_widget(vbox, &hbox1->w, 0);

	/* create a radio handler within the current widow */
	hrr = mbtk_handler_hovradio_alloc(win);

	/* create a radio button.... */
	wrb = mbtk_radiobutton_new(NULL);
	mbtk_radiobutton_callback_toggle(wrb, button_toggle, "radio 1");
	mbtk_box_add_widget(hbox1, &wrb->w, 0);
	mbtk_handler_hovradio_add_widget(hrr, &wrb->w); /* add to the radio handler; this groups our radio buttons */

	/* create a second radio button.... */
	wrb = mbtk_radiobutton_new(NULL);
	mbtk_radiobutton_callback_toggle(wrb, button_toggle, "radio 2");
	mbtk_box_add_widget(hbox1, &wrb->w, 0);
	mbtk_handler_hovradio_add_widget(hrr, &wrb->w);


	/* create a third button.... */
	wrb = mbtk_radiobutton_new(NULL);
	mbtk_radiobutton_callback_toggle(wrb, button_toggle, "radio 3");
	mbtk_box_add_widget(hbox1, &wrb->w, 0);
	mbtk_radiobutton_style_set_prop(wrb, mbtk_kw("fg.color"), mbtk_arg_str("#ff0000")); /* change the foreground color, which is the color of the mark */
	mbtk_handler_hovradio_add_widget(hrr, &wrb->w);

	for(stay = 1; stay;) {
		mbtk_event_t ev;
		if (mbtk_iterate(&disp, &ev, 1)) {
			if (ev.type == MBTK_EV_KEY_RELEASE) {
				if (ev.data.key.sym == 'q')
					break;
			}
		}
	}

	mbtk_uninit();
}
